%{
  #include <ctype.h>
  #include <string.h>

  static int first_time=1;
  static int lex_i;
  static unsigned char lex_c;
  static int filenumber=0;
  extern FILE *file, *fileptk, *fileinf, *fileerr;
  extern int verbose, fileerrors;
  static char Descr[200];
  static char DescrOld[200];
  static char Nummer[200];
  static char Buffer[200];
  static char OldFName[200];
  static int gotend=1;
  static int catfile=0;
  static int expected_end=0;
  static char Buffer2[1000];

  /*
    $Log: getuuenc.lex,v $
# Revision 1.5  1996/06/18  01:58:30  sven
# *** empty log message ***
#
# Revision 1.4  1996/06/18  01:56:29  sven
# ok
#
# Revision 1.3  1996/06/18  00:58:56  sven
# *** empty log message ***
#
  */   

%}

%s S_HEADER0 S_HEADER1 S_DATA0 S_DATA1 S_DATA2 S_DATA3 S_NORMAL_

%p 8000

%%


%{
  if(first_time)
  {
    BEGIN S_NORMAL_;
    first_time=0;
    gotend=1;
    Descr[0]=0 ;
    strcpy(OldFName," ");
    fileerrors=0;
  }
%}

<S_NORMAL_>.|\n   { }
<S_NORMAL_>^From\:\  { BEGIN S_HEADER0; }

<S_HEADER0>Subject\:\  {
                  fprintf(stderr,"*"); 
                  strcpy(DescrOld,Descr);
                  Descr[0]=0 ;
                  lex_i=0;

                  while((lex_c=input())!='\n' && lex_i<200)
                  {
                    Descr[lex_i++]=lex_c;
                  }
                  Descr[lex_i]=0;
                  fprintf(fileinf,"\n%s:\nreceived\n", Descr);
                  BEGIN S_HEADER1;
                  if(gotend==0)
                  {
                    if(strstr(Descr, OldFName)==0) 
                    {
                      gotend=1;
                      fprintf(fileinf,"\n%s:\ndo not glue emails, because of filename '%s'\ndoes not fit in upper description!\n", Descr, OldFName);
                     }
                  }
                  if(verbose) fprintf(stderr," %s\n", Descr); 
               }
<S_HEADER0>.|\n { }

<S_HEADER1>^[ \t]*[\n\r] { BEGIN S_DATA0; }
<S_HEADER1>.|\n { }
<S_HEADER1>^From\:\  { BEGIN S_HEADER0; 
                        fprintf(fileerr,"\n%s:\nwrong email format (missing blank line) skipping email !\n", Descr);
                        fprintf(fileerr,"\nLAST SCANNES THING :\nSTART\n%s\nEND\n", yytext);
                        fileerrors++;
                      }

<S_DATA0>begin { BEGIN S_DATA1; }
<S_DATA0>.|\n { if(gotend==0 && yytext[0]=='M')
                {
                  unput(yytext[0]);
                  BEGIN S_DATA3;
                  fprintf(fileinf,"\n%s:\ntrying to connect email with file %s !\n", Descr, OldFName);
                  if(fileptk!=NULL) fprintf(fileptk,"      +=  %s\n", Descr);
                  catfile=1;
                }
              }
<S_DATA0>^From\:\  { BEGIN S_HEADER0;
                      fprintf(fileinf,"\n%s:\nno usefull email-data !\n", Descr);
                    }
<S_DATA1>[0-9]+ { BEGIN S_DATA2; strcpy(Nummer, yytext); }
<S_DATA1>.|\n { }
<S_DATA1>^From\:\  { BEGIN S_HEADER0; 
                      fprintf(fileerr,"\n%s:\nwrong uuencode format (missing filemode) skipping email !\n", Descr);
                        fprintf(fileerr,"\nLAST SCANNES THING :\nSTART\n%s\nEND\n", yytext);
                      fileerrors++;
                    }

<S_DATA2>[a-zA-Z0-9\.\_\!\%\=\?\#\+\-\:\;]+ { BEGIN S_DATA3;
                  filenumber++;
                  if(fileptk!=NULL)
                    fprintf(fileptk,"\n\n%s = %d.uue :%s\n", yytext, filenumber, Descr);
                  if(file) fclose(file);
                  sprintf(Buffer,"%d.uue", filenumber);
                  file=fopen(Buffer,"wt");  
                  if(!file) 
                  {
                    fprintf(stderr,"can't open Files '%s'\n", Buffer);
                    exit(1);
                  }
                  fprintf(file, "begin %s %s\n", Nummer, yytext);
                  fprintf(fileinf,"\n%s:\ncontains uuencoded data file %s\n", Descr, yytext);
                  gotend=0;
                  strcpy(OldFName,yytext);
                }
<S_DATA2>.|\n { }
<S_DATA2>^From\:\  { BEGIN S_HEADER0; 
                      fprintf(fileerr,"\n%s:\nwrong uuencode format (missing filename) skipping email !\n", Descr);
                        fprintf(fileerr,"\nLAST SCANNES THING :\nSTART\n%s\nEND\n", yytext);
                      fileerrors++;
                    }

<S_DATA3>^end { BEGIN S_NORMAL_; 
                if(expected_end)
                {
                  fprintf(file, "%s", Buffer2);
                  expected_end=0;
                }   
                fprintf(file, "end\n"); 
                gotend=1;
                fclose(file); 
                file=NULL;
              }

<S_DATA3>^From  { BEGIN S_HEADER0; 
                  fprintf(fileinf,"\n%s:Got 'From'\nmissing uuencode-word 'end' (try to connect with next e-mail) !\n", Descr);
                }

<S_DATA3>^M.*\n { fprintf(file, "%s", yytext); 
                  Buffer2[0]=0;
                  expected_end=0;
                }

<S_DATA3>M.*\n {  if(catfile)
                  {
                    fprintf(file, "%s", yytext); 
                    Buffer2[0]=0;
                    expected_end=0;
                    catfile=0;
                  }
                  else
                  {
                    expected_end=1;
                    strcat(Buffer2, yytext);
                  }   
                }

             
<S_DATA3>^[ \t]*\n {  BEGIN S_HEADER0;
                      fprintf(fileinf,"\n%s:Got blank line\nmissing uuencode-word 'end' (try to connect with next e-mail) !\n", Descr);
                   }
<S_DATA3>.|\n { expected_end=1;
                strcat(Buffer2, yytext);
              }
              

%%

int  yywrap  (void) { return 1; }  /* EOF processing */

